#version 430 core

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 uv;
layout(location = 3) in vec4 offset_and_life;

out VertexData {
	vec3 position_world;
	vec3 normal_world;
	vec2 uv;
} vert;

uniform mat4 modelMatrix;
uniform mat4 viewProjMatrix;
uniform mat3 normalMatrix;

void main() {
	vert.normal_world = normalMatrix * normal;
	vert.uv = uv;
	vec3 offset = vec3(offset_and_life.x, offset_and_life.y, offset_and_life.z);
	vec4 position_world_ = modelMatrix * vec4(position + offset, offset_and_life.w > 0.0f ? 1 : 0);
	vert.position_world = position_world_.xyz;
	gl_Position = viewProjMatrix * position_world_;
}